#ifndef PAS_A_PAS_H
#define PAS_A_PAS_H

#include "barriere.h"
#include <Arduino.h>

class pas_a_pas : public barriere
{
    public:
        pas_a_pas();
        // le constructeur
        pas_a_pas(int pina, int pinb, int pinc, int pind,int degre, int vitesse);
        // le destructeurs
        virtual ~pas_a_pas();
        // renvoie les pin de commande des barrieres
        int broche(int num) {switch(num) {
                                case 1 : {return pin1; break;}
                                case 2 : {return pin2;break;}
                                case 3 : {return pin3; break;}
                                case 4 : {return pin4; break;}
                                default : return 0;
                                }}
        // la methode ouverture de la barriere
        void ouverture();
        // la methode fermeture de la barriere
        void fermeture();
        // la methode manoeuvre de la barriere
        void manoeuvre();
    protected:
    private:
        // les 8 sequences pour le moteur pas a pas (1,1&2,2,2&3,3,3&4,4,4&1)
        int phases[8] = {0x08, 0x0C, 0x04, 0x06, 0x02, 0x03, 0x01, 0x09};
        // envoie les 8 sequences pour le moteur pas a pas
        void impulsions(int out);
        // arret du moteur
        void halt();
         // pins de commande
        int pin1;
        int pin2;
        int pin3;
        int pin4;
        // vitesse de rotation du moteur, duree en us de chaque sequence
        int _vitesse;
        // angle de deviation du moteur
        int angle;
        // compteur de pas
        int counter;
        // nombre de pas en fonction de l'angle choisi
        int pas;
};

#endif // PAS_A_PAS_H
