#ifndef ZONE_H
#define ZONE_H

#include "capteur.h"
#include <Arduino.h>

/******************************************************************
La classe zone : elle represente un ensemble de capteurs
ayant une caracteristique particulliere, demande d'ouverture ou
de fermeture du passage a niveau, les capteurs d'une zone ont tous le
meme role
constructeur :
    rien
    un nom
Les methodes :
    bool add(sensor &) : ajoute un capteur a la zone
    void print() : affiche la configuration de la zone
    char* getName : renvoie le nom de la zone
    bool update() : met a jour les capteurs de la zone
    bool actif() : renvoie vrai si au moins un capteur de la zone est active
*******************************************************************************/

class zone
{
    private:
    // la liste des capteurs de la zone
    typedef struct element {
    capteur *detecteur;
    element *suivant = nullptr;     // un pointeur vers l'�l�ment suivant
    };

    element *debut = nullptr;       // pointeur de debut de la liste
    element *fin = nullptr;         // pointeur de fin de la liste

    char* _nom = "";              // le nom de la zone
    bool premier(capteur **);          // intialise le parcours de la liste en se mettant au debut
    bool suivant(capteur **);          // parcours les autres capteurs de la liste
    element *index = nullptr;       // index pour la parcours de la liste

    public:
        // les constructeurs
        zone();
        zone(char* nom);
        // le destructeur
        virtual ~zone();

        // ajoute un capteur
        bool add(capteur &);
        // affiche la configuration de la zone (si mode console)
        void print();
        // renvoie le nom de la zone
        char* nom(){return _nom;}
        // mise a jour des capteurs de la zone
        bool actualiser();
        // au moins un capteur est active
        bool actif();
    protected:

};
#endif // ZONE_H
